Index: trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc
===================================================================
--- trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1007)
+++ trunk/source/processes/hadronic/models/chiral_inv_phase_space/body/src/G4QEnvironment.cc	(revision 1055)
@@ -1118,11 +1131,116 @@
       G4Quasmon* curQuasmon = new G4Quasmon(valQ, q4Mom, -proj4M);//Interact gam+q inside
       theQuasmons.push_back(curQuasmon);  // Insert Quasmon without incid. gamma (del.eq.)
-	   }
-    else if(projPDG==2212 && G4UniformRand()>.5) // Bad for ions! Only for baryons !
-    //else if(2>3)                          // free flying proton is closed
-	   {
-      q4Mom=proj4M;       // 4M: QUASMON=Projectile
-      valQ=EnFlQC;        // qc: QUASMON=Projectile
+    }
+    //else if(Pr1&&projPDG==2212&&G4UniformRand()<.6+.4*std::exp(-envMass/8192))// keepProj
+    else if(2>3)                          // free flying projectile is closed
+    {
+      q4Mom=proj4M;                       // 4M: QUASMON=Projectile
+      valQ=EnFlQC;                        // qc: QUASMON=Projectile
       theEnvironment=memEnviron;
+#ifdef pdebug
+      G4cout<<"G4QEnv::CreQAll: Q="<<q4Mom<<valQ<<", QEnv="<<theEnvironment<<G4endl;
+#endif
+      G4Quasmon* curQuasmon = new G4Quasmon(valQ, q4Mom);
+      theQuasmons.push_back(curQuasmon);  // Insert Quasmon (even hadron/gamma) (del.eq.)
+    }
+    else if(Pr1&&projPDG==2212&&G4UniformRand()>15./(proj4M.e()-mProt))//ExcitatedCluster
+    //else if(2>3)                          // No excitation of a cluster by projScattering
+    {
+      G4double prM=mProt;                 // mass of the projectile (M) (for future gener.)
+      G4double prM2=mPro2;                // squared mass of the projectile (M^2)
+      G4double scM=mProt;                 // mass of the scattered projectile (M')
+      G4double scM2=mPro2;                // squared mass of the scatteredProjectile (M'^2)
+      G4QContent scQC=projQC;             // QC of the scattered projectile
+      G4QContent chQC(0,0,0,0,0,0);       // Change of the Quasmon QC
+      if(G4UniformRand()<.5*envN/envBN)   // (u->u,d, d->d)? in future make it universal
+      {
+        scM=mNeut;                        // Charge exchange reaction
+        scM2=mNeu2;
+        scQC=neutQC;
+        chQC=projQC-scQC;                 // Charge of the created Quasmon must be changed
+      }
+      G4double tnM=tgMass-envMass;        // minimal mass of the target cluster (m)
+      G4double tnM2=tnM*tnM;              // squared mass of the target cluster (m^2)
+      G4double dtnM=tnM+tnM;              // doubled mass of the target cluster (2*m)
+      G4double prE=proj4M.e();            // enrgy of the projectile (E)
+      G4double mu2=tnM2+dtnM*(prE-scM);   // max squared mass of the excited cluster (mu^2)
+      //G4double mu=std::sqrt(mu2);         // max mass of the excited cluster (mu)
+      G4double B=.00001;                  // (parameter) slope of the diffraction cone
+      G4double rmu2=0.;                   // Chosen sqMass of excitedClust (Prototype)
+      G4double tmax=0.;                   // max -t for scattering (Prototype)
+      G4double rt=0.;                     // Chosen -t (Prototype)
+      G4double om=0.;                     // Energy of the excited cluster (Prototype)
+      G4double ep=0.;                     // Energy of the scattered projectile (eps Proto)
+      if (prE<prM)G4cout<<"-Warn-G4QEnv::CreQAll:(scat w ex)E="<<prE<<" < M="<<prM<<G4endl;
+      G4double Pi=std::sqrt(prE*prE-prM2); // Proj momentum (P)
+      G4double po=0.;                      // Scat momentum (p) (Prototype)
+      G4double cost=2.;                    // cos(theta) for the scattered proj (Prototype)
+      G4int cct=0;                         // Counter of cost attempts (@@ can be limited)
+      while ( std::fabs(cost) > 1. )
+      {
+        cct++;
+#ifdef debug
+        G4cout<<"-Warning-G4QEnv::CreQAll: c="<<cct<<" (scat w ex) cost="<<cost<<G4endl;
+#endif
+        rmu2=tnM2*pow(mu2/tnM2,G4UniformRand()); // Chosen SqMass of excitedClust (MMA)
+        tmax=mu2-rmu2;                    // max -t for scattering
+        rt=-std::log(1.-G4UniformRand()*(1.-std::exp(-B*tmax)))/B; // Chosem -t
+        om=(tnM2+rmu2+rt)/dtnM;           // Energy of the excited cluster
+        ep=prE+tnM-om;                    // Energy of the scattered projectile (epsilon)
+#ifdef pdebug
+        G4cout<<"G4QEnv::CreQAll: m2="<<tnM2<<" < mu2="<<rmu2<<" < "<<mu2<<"=Max2"<<G4endl;
+        G4cout<<"G4QEnv::CreQAll: -t="<<rt<<" < "<<tmax<<"=tmax"<<G4endl;
+        G4cout<<"G4QEnv::CreQAl: om="<<om<<" > m="<<tnM<<", ep="<<ep<<" > M="<<prM<<G4endl;
+#endif
+        if(ep<scM)G4cout<<"+Warn-G4QEnv::CreQAl:(scat w ex)Eo="<<prE<<" < M="<<prM<<G4endl;
+        po=std::sqrt(ep*ep-scM2);   // Scat momentum (p)
+        cost=(prE*ep-0.5*(rt+prM2+scM2))/Pi/po; // cos(theta) for the scattered
+      }
+      G4double om2=om*om;
+      if(om2<rmu2)G4cout<<"-Warn-G4QEnv::CreQA:(scat w ex)e2="<<om<<" < mu2="<<tnM<<G4endl;
+#ifdef pdebug
+      G4cout<<"G4QEnv::CreQAll: ct="<<cost<<",pio="<<Pi*po<<",()="<<cost*Pi*po<<G4endl;
+      G4double ps=std::sqrt(om2-rmu2);    // Momentum of the excited cluster (p)
+#endif
+      G4double pfc=po*cost;               // Longitudinal projection of the scattered proj
+      G4double pfs=po*std::sqrt(1.-cost*cost); // Transversal projection of scattered proj
+      // ---- @@ From here can be a MF for QF nucleon extraction (if used by others)
+      G4ThreeVector vdir = proj4M.vect(); // 3-Vector in the projectile direction
+      G4ThreeVector vx(0.,0.,1.);         // ProtoOrt in the direction of the projectile
+      G4ThreeVector vy(0.,1.,0.);         // First ProtoOrt orthogonal to the direction
+      G4ThreeVector vz(1.,0.,0.);         // Second ProtoOrt orthoganal to the direction
+      if(vdir.mag2() > 0.)                // the projectile isn't at rest
+      {
+        vx = vdir.unit();                 // Ort in the direction of the projectile
+        G4ThreeVector vv= vx.orthogonal();// Not normed orthogonal vector (!)
+        vy = vv.unit();                   // First ort orthogonal to the proj. direction
+        vz = vx.cross(vy);                // Second ort orthoganal to the proj. direction
+      }
+      // ---- @@ End of possible MF (Similar is in G4QCollision)
+      G4double phi=twopi*G4UniformRand(); // Phi of the Fermi-Mom
+      G4ThreeVector fp=pfc*vx+pfs*(std::sin(phi)*vy+std::cos(phi)*vz);
+      G4LorentzVector s4M(fp,ep);
+#ifdef pdebug
+      G4cout<<"G4QEnv::CreQA:ps="<<po<<"="<<fp.mag()<<",sM="<<prM<<"="<<s4M.m()<<G4endl;
+      G4cout<<"G4QEnv::CreQA:Ee="<<prE*ep<<" =? "<<(prM2+rt/2-Pi*po*cost)<<G4endl;
+#endif
+      if(std::fabs(s4M.m()-scM)>.001)G4cout<<"-W-G4QE::CQA:M="<<prM<<"#"<<s4M.m()<<G4endl;
+      G4LorentzVector c4M=proj4M+G4LorentzVector(0.,0.,0.,tnM)-s4M;
+#ifdef pdebug
+      G4cout<<"G4QEnv::CreQA: ec="<<om<<" = "<<c4M.e()<<", pc="<<ps<<" = "
+            <<c4M.rho()<<", mc2="<<rmu2<<" = "<<c4M.m2()<<G4endl;
+      G4cout<<"G4QEnv::CQA:ht="<<(tnM2+rmu2)/2-tnM*om<<"="<<prM2-prE*ep+Pi*po*cost<<G4endl;
+#endif
+      if(std::fabs(c4M.m2()-rmu2)>.1)
+        G4cout<<"-W-G4QE::CrQ:m2="<<rmu2<<"#"<<c4M.m2()<<",P="<<proj4M<<",M="<<tnM<<G4endl;
+      G4QHadron* projH = new G4QHadron(scQC,s4M); // Create scattered Projectile Hadron
+      theQHadrons.push_back(projH);       // Fill it to the output vector
+      G4Quasmon* curQuasmon = new G4Quasmon(curQC+chQC, c4M); // Q=ExcitedCluster
+      theQuasmons.push_back(curQuasmon); // Insert Quasmon (even hadron/gamma) (del.eq.)
+    }
+    else
+    {
+      q4Mom=proj4M+G4LorentzVector(0.,0.,0.,tgMass-envMass); // Projectile + BoundCluster
+      valQ=EnFlQC+curQC;
 #ifdef pdebug
       G4cout<<"G4QEnv::CreQAll: Q="<<q4Mom<<valQ<<", QEnv="<<theEnvironment<<G4endl;
@@ -1130,15 +1248,5 @@
       G4Quasmon* curQuasmon = new G4Quasmon(valQ, q4Mom);
       theQuasmons.push_back(curQuasmon); // Insert Quasmon (even hadron/gamma) (del.eq.)
-	   }
-    else
-	   {
-      q4Mom=proj4M+G4LorentzVector(0.,0.,0.,tgMass-envMass);//Projectile + BoundCluster
-      valQ=EnFlQC+curQC;
-#ifdef pdebug
-      G4cout<<"G4QEnv::CreQAll: Q="<<q4Mom<<valQ<<", QEnv="<<theEnvironment<<G4endl;
-#endif
-      G4Quasmon* curQuasmon = new G4Quasmon(valQ, q4Mom);
-      theQuasmons.push_back(curQuasmon); // Insert Quasmon (even hadron/gamma) (del.eq.)
-	   }
+    }
   }
   else
@@ -1167,8 +1275,8 @@
     G4int cCH  = curCand->GetCharge();             // Charge of the candidate
 #ifdef sdebug
-	   G4cout<<"G4QE::PIP:=====> #"<<index<<", cPDG="<<cPDG<<",S="<<cST<<G4endl;
+    G4cout<<"G4QE::PIP:=====> #"<<index<<", cPDG="<<cPDG<<",S="<<cST<<G4endl;
 #endif
     if(cPDG>80000000&&cPDG!=90000000&&!cST&&cCH>0&&cBN>0&&cCH<=cBN) // ===> Nuclear cluster
-	   {
+    {
       G4int zc = cCH;                              // "Z" of the cluster
       G4int nc = cBN-cCH;                          // "N" of the cluster
@@ -1176,11 +1284,11 @@
       G4double dOfCl=curCand->GetDenseProbability();// A number of clusters in dense region
 #ifdef sdebug
-						G4cout<<"G4QE::PIP:Z="<<zc<<",N="<<nc<<",nC="<<nOfCl<<",dC="<<dOfCl<<G4endl;
+      G4cout<<"G4QE::PIP:Z="<<zc<<",N="<<nc<<",nC="<<nOfCl<<",dC="<<dOfCl<<G4endl;
 #endif
       if(cPDG==91000000||cPDG==90001000||cPDG==90000001)
-	     {
+      {
         allB+=nOfCl;
         denseB+=dOfCl;
-	     }
+      }
       G4QContent pQC=curCand->GetQC();             // Quark Content of the candidate
       ////////////G4int pC   = projQC.GetCharge();   // Charge of the projectile
@@ -1220,8 +1328,8 @@
       G4double charge= qQC.GetCharge();
       G4double dq= abs(baryn-charge-charge);
-	     G4cout<<"G4QE::PIP:P="<<probab<<",ac="<<cBN<<",dq="<<dq<<",f="<<fact<<",qC="
+      G4cout<<"G4QE::PIP:P="<<probab<<",ac="<<cBN<<",dq="<<dq<<",f="<<fact<<",qC="
             <<qC<<",rPDG="<<rPDG<<",pPDG="<<pPDG<<",nCP="<<nOfCl<<",dCP="<<dOfCl<<G4endl;
 #endif
-	   }
+    }
     else probab=0.;
     sum+=probab;
@@ -1243,5 +1351,5 @@
     G4int clustQCode = i+90; // Q-code of the cluster in the CHIPS World "IsoNuclei"
 #ifdef sdebug
-	   G4cout<<"G4QEnvironment::InitClustersVector: Before Init Q ="<<clustQCode<<G4endl;
+    G4cout<<"G4QEnvironment::InitClustersVector: Before Init Q ="<<clustQCode<<G4endl;
 #endif
     G4QPDGCode clustQPDG(true,clustQCode);
@@ -1250,8 +1358,8 @@
     G4int clustB=clustQPDG.GetBaryNum();
 #ifdef sdebug
-	   G4cout<<"G4QEnvironment::InitClustersVector: Before insert ="<<clusterPDG<<G4endl;
-#endif
-	   //theQCandidates.push_back(new G4QCandidate(clusterPDG)); // (delete equivalent)
-	   if(clustB<=maxA) theQCandidates.push_back(new G4QCandidate(clusterPDG)); // (del.eq.)
+    G4cout<<"G4QEnvironment::InitClustersVector: Before insert ="<<clusterPDG<<G4endl;
+#endif
+    //theQCandidates.push_back(new G4QCandidate(clusterPDG)); // (delete equivalent)
+    if(clustB<=maxA) theQCandidates.push_back(new G4QCandidate(clusterPDG)); // (del.eq.)
 #ifdef sdebug
     G4cout<<"G4QEnvironment::InitClustersVector: Cluster # "<<i<<" with code = "
@@ -1272,4 +1380,6 @@
   static const G4QContent SiPQC(0,2,1,0,0,0);
   static const G4QContent SiMQC(2,0,1,0,0,0);
+  static const G4QContent protQC(1,2,0,0,0,0);
+  static const G4QContent neutQC(2,1,0,0,0,0);
   //static const G4QContent alQC(6,6,0,0,0,0);
   static const G4QPDGCode nQPDG(2112);
@@ -1328,15 +1438,15 @@
     G4int nPDG = theEnvironment.GetPDG();    // PDG code of the residual Nucl.Environ.
 #ifdef pdebug
-	   G4cout<<"G4QE::HQE:***NO QUASMONS***Env="<<nPDG<<theEnvironment.Get4Momentum()<<G4endl;
+    G4cout<<"G4QE::HQE:***NO QUASMONS***Env="<<nPDG<<theEnvironment.Get4Momentum()<<G4endl;
 #endif
     if(nPDG==90000000) return theQHadrons;
     if(nPDG>80000000)
-	   {
+    {
       G4QHadron* rNucleus = new G4QHadron(theEnvironment); // Create HadronEnvironment
       theQHadrons.push_back(rNucleus);       // Fill GS - no further decay (del. equiv.)
 #ifdef fdebug
-	     G4cout<<"G4QEnv::HadrQE: >>>> Fill Environment="<<theEnvironment<<G4endl;
-#endif
-	   }
+      G4cout<<"G4QEnv::HadrQE: >>>> Fill Environment="<<theEnvironment<<G4endl;
+#endif
+    }
     return theQHadrons;
   }
@@ -1347,11 +1457,11 @@
     G4int totInC=0;
     G4LorentzVector totIn4M(0.,0.,0.,0.);
-	   for (G4int is=0; is<nQuasmons; is++)     // Sum4mom's of Quasmons for the comparison
-	   {
-	     G4Quasmon*      pQ = theQuasmons[is];
+    for (G4int is=0; is<nQuasmons; is++)     // Sum4mom's of Quasmons for the comparison
+    {
+      G4Quasmon*      pQ = theQuasmons[is];
       G4LorentzVector Q4M= pQ->Get4Momentum();
       totIn4M           += Q4M;
       totInC            += pQ->GetQC().GetCharge();
-	   } // End of TotInitial4Momentum summation LOOP over Quasmons
+    } // End of TotInitial4Momentum summation LOOP over Quasmons
     G4int nsHadr  = theQHadrons.size();      // Update the value of OUTPUT entries
     if(nsHadr) for(G4int jso=0; jso<nsHadr; jso++)// LOOP over output hadrons 
@@ -1368,7 +1478,7 @@
     G4QNucleus vE(90000000);
     G4int     nlq = 0;                       // Prototype of a#of Living Quasmons
-	   if(nQuasmons) for(G4int lq=0; lq<nQuasmons; lq++)if(theQuasmons[lq]->GetStatus())nlq++;
-	   if(nQuasmons) for(G4int iq=0; iq<nQuasmons; iq++)
-	   {
+    if(nQuasmons) for(G4int lq=0; lq<nQuasmons; lq++)if(theQuasmons[lq]->GetStatus())nlq++;
+    if(nQuasmons) for(G4int iq=0; iq<nQuasmons; iq++)
+    {
 #ifdef chdebug
       G4int f1Charge=theEnvironment.GetCharge();
@@ -1404,5 +1514,5 @@
       G4int ist=theQuasmons[iq]->GetStatus();// Status of the Quasmon before fragmentation
       if(ist)
-	     {
+      {
         G4QHadronVector* output=theQuasmons[iq]->Fragment(vE,1);//!!!DESTROY!!! <---------+
         G4int ast=theQuasmons[iq]->GetStatus();  // Quasmon's Status after fragmentation  ^
@@ -1413,6 +1523,6 @@
 #endif
         if(nHadrons>0)                           // Copy QHadrons-Quasmon to Output       ^
-	       {
-    	     for (G4int ih=0; ih<nHadrons; ih++)    // LOOP over QHadrons of the Quasmon     ^
+        {
+          for (G4int ih=0; ih<nHadrons; ih++)    // LOOP over QHadrons of the Quasmon     ^
           {
             //G4QHadron* curH=new G4QHadron(output->operator[](ih));// (Del 7 lines below)^
@@ -1424,7 +1534,7 @@
             theQHadrons.push_back(curH);         // Fill hadron-copy (delete equivalent)  ^
           }
-	       }                                        //                                       ^
+        }                                        //                                       ^
         else                                     // => "Quasmon can't decay" case         ^
-								{                                        //                                       ^
+        {                                        //                                       ^
           G4QContent totQC=theQuasmons[iq]->GetQC();//                                    ^
           G4int     tQBN=totQC.GetBaryonNumber();// Baryon Number of not decayed Quasmon  ^
@@ -1434,5 +1544,5 @@
           G4double totQM=tot4M.m();              // Real Mass of Quasmon                  ^
           if(tQBN>0&&totQM>gsM)                  // => "Try Quasmon evaporation" case     ^
-										{                                      //                                       ^
+          {                                      //                                       ^
             G4QHadron* nuclQ = new G4QHadron(totQC,tot4M); //                             ^
 #ifdef fdebug
@@ -1442,25 +1552,25 @@
             theQuasmons[iq]->KillQuasmon();      // Kill evaporated Quasmon               ^
             nlq--;                               //                                       ^
-		        }
+          }
           else if(iq+1<nQuasmons&&nlq>1)         // => "Try to merge with next" case      ^
-		        {
+          {
             G4int s=theQuasmons[iq+1]->GetStatus();//Status of the next Quasmon           ^
             theQuasmons[iq+1]->IncreaseBy(theQuasmons[iq]);// Merge with the next Quasmon ^
             theQuasmons[iq]->KillQuasmon();      // Kill the week Quasmon                 ^
             if(s) nlq--;                         // Reduce a number of "living Quasmons"  ^
-		        }
+          }
           else if(iq+1==nQuasmons&&iq&&nlq>1)    // => "Quasmon stack is exhosted" case   ^
-		        {
+          {
             G4int s=theQuasmons[0]->GetStatus(); // Status of the first Quasmon           ^
             theQuasmons[0]->IncreaseBy(theQuasmons[iq]);// Merge with the first Quasmon   ^
             theQuasmons[iq]->KillQuasmon();      // Kill the week Quasmon                 ^
             if(s) nlq--;                         // Reduce a number of "living Quasmons"  ^
-		        }
-		        else                                   // "Have a chance to recover" case       ^
-		        {                                      //                                       ^
-#ifdef pdebug
-		          G4cout<<"***G4QE::HQE:"<<iq<<",n="<<nHadrons<<",Tot="<<totQC<<totQM<<G4endl;//^
-		          for (G4int kq=0; kq<nQuasmons; kq++) // LOOP over Quasmons for DEBUG PRINTING ^
-														G4cout<<kq<<",St/QC="<<theQuasmons[kq]->GetStatus()<<theQuasmons[kq] //     ^
+          }
+          else                                   // "Have a chance to recover" case       ^
+          {                                      //                                       ^
+#ifdef pdebug
+            G4cout<<"***G4QE::HQE:"<<iq<<",n="<<nHadrons<<",Tot="<<totQC<<totQM<<G4endl;//^
+            for (G4int kq=0; kq<nQuasmons; kq++) // LOOP over Quasmons for DEBUG PRINTING ^
+              G4cout<<kq<<",St/QC="<<theQuasmons[kq]->GetStatus()<<theQuasmons[kq] //     ^
                     ->GetQC()<<",M="<<theQuasmons[kq]->Get4Momentum().m()<<G4endl; //     ^
 #endif
@@ -1469,5 +1579,5 @@
             G4bool corrf = true;                 // False when corrected & needs to quit  ^
             while(nOfOUT && corrf)               // LOOP over all existing QHadrons       ^
-			         {                                    //                                       ^
+            {                                    //                                       ^
               G4QHadron*     theLast = theQHadrons[nOfOUT-1];     //  Remember            ^
               G4LorentzVector last4M = theLast->Get4Momentum();   //  all                 ^
@@ -1477,5 +1587,5 @@
               G4int           nFr    = theLast->GetNFragments();  //  Last  // if()       ^
               G4int           gam    = theLast->GetPDGCode();     //        //            ^
-			           if(gam!=22&&!nFr&&lastS<0&&lastS+totS<0&&nOfOUT>1)//=> Skip K,gam & decayed ^
+              if(gam!=22&&!nFr&&lastS<0&&lastS+totS<0&&nOfOUT>1)//=> Skip K,gam & decayed ^
               {                                  //                                       ^
                 G4QHadron* thePrev = theQHadrons[nOfOUT-2];// Kill Prev & make Last->Prev ^
@@ -1487,10 +1597,10 @@
                 last4M = theLast->Get4Momentum();// 4Mom of the previouse Quasmon         ^
                 lastQC = theLast->GetQC();       // Quark Content of the previouse Quasmon^
-			           }                                  //                                       ^
+              }                                  //                                       ^
               else                               // Just Clear and destroy theLast        ^
-			           {                                  //                                       ^
+              {                                  //                                       ^
                 theQHadrons.pop_back();          // theLastQHadron is excluded from OUTPUT^
                 delete         theLast;          // theLastQHadron is deleated as instance^
-			           }                                  //                                       ^
+              }                                  //                                       ^
               totQC+=lastQC;                     // Update (increase) the total QC        ^
               tot4M+=last4M;                     // Update (increase) the total 4-momentum^
@@ -1500,5 +1610,5 @@
               dM = totQM-gsM;                    // Escitation energy for the Quasmon     ^
               if(dM>0)                           // "Mass of Q is big enough" case        ^
-			           {                                  //                                       ^
+              {                                  //                                       ^
                 theQuasmons[iq]->InitQuasmon(totQC,tot4M);// Update the week Quasmon      ^
                 G4QHadronVector* curout=theQuasmons[iq]->Fragment(vE,1);//!DESTROY! <---+ ^
@@ -1510,7 +1620,7 @@
 #endif
                 if(nHadrons>0)                   // => "QHadrons from Quasmon to Output"^ ^
-				            {                                //                                     ^ ^
-    	             for (G4int ih=0; ih<nHadrons; ih++) // LOOP over Hadrons of theQuasmon^ ^
-				              {                              //                                     ^ ^
+                {                                //                                     ^ ^
+                  for (G4int ih=0; ih<nHadrons; ih++) // LOOP over Hadrons of theQuasmon^ ^
+                  {                              //                                     ^ ^
                     //G4QHadron* curH = new G4QHadron(curout->operator[](ih)); //       ^ ^
                     G4QHadron* curH = new G4QHadron((*curout)[ih]); //                  ^ ^
@@ -1520,5 +1630,5 @@
 #endif
                     totQC-=curH->GetQC();        // totQC recalculation                 ^ ^
-					               tot4M-=curH->Get4Momentum(); // tot4M recalculation                 ^ ^
+                    tot4M-=curH->Get4Momentum(); // tot4M recalculation                 ^ ^
                     theQHadrons.push_back(curH); // Fill hadron-copy (delete equivalent)^ ^
                     //delete curout->operator[](ih);//>-Necessary to delete instances*>-^ ^
@@ -1529,21 +1639,21 @@
                   corrf = false;                 // Corrected: go out of the while loop ^ ^
                   //break;                       // @@ ??                               ^ ^
-	               } // End of check for existing output Hadrons in the Quasmon            ^ ^
+                } // End of check for existing output Hadrons in the Quasmon            ^ ^
                 else                             //                                     ^ ^
-				            {                                //                                     ^ ^
+                {                                //                                     ^ ^
                   for_each(curout->begin(), curout->end(), DeleteQHadron()); // >-------^ ^
                   curout->clear();               //                                     ^ ^
                   delete curout;                 //>*Necessary to delete VectPointers>--^ ^
-				            }                                //                                       ^
-			           }                                  //                                       ^
+                }                                //                                       ^
+              }                                  //                                       ^
               nOfOUT  = theQHadrons.size();      // Update the value of OUTPUT entries    ^
 #ifdef rdebug
               G4int tC=totInC;                   // Vacuum: No ResidualEnvironCharge      ^
               G4LorentzVector t4M=totIn4M;       // Vacuum: No ResidualEnvironment 4-Mom  ^
-	             for (G4int js=0; js<nQuasmons; js++) // Subtract 4mom's of Quasmons from dif^
-			           {                                  //                                       ^
-	               G4Quasmon*      pQ = theQuasmons[js]; //                                  ^
+              for (G4int js=0; js<nQuasmons; js++) // Subtract 4mom's of Quasmons from dif^
+              {                                  //                                       ^
+                G4Quasmon*      pQ = theQuasmons[js]; //                                  ^
                 if(pQ->GetStatus())              // Subtract only if Quasmon is alive     ^
-				            {                                //                                       ^
+                {                                //                                       ^
                   G4LorentzVector Q4M= pQ->Get4Momentum(); //                             ^
                   t4M               -= Q4M;                //                             ^
@@ -1551,7 +1661,7 @@
                 }                                //                                       ^
                 else G4cout<<"G4QE::HQ:SUM-4-Mom s("<<js<<")="<<pQ->GetStatus()<<G4endl;//^
-	             } // End of Quasmons4Momentum subtractions                                  ^
+              } // End of Quasmons4Momentum subtractions                                  ^
               if(nOfOUT) for(G4int jpo=0; jpo<nOfOUT; jpo++)// LOOP over output hadrons   ^
-			           {                                  //                                       ^
+              {                                  //                                       ^
                 G4int hsNF  = theQHadrons[jpo]->GetNFragments();//A#of secondary fragments^
                 if(!hsNF)                                   // Subtract only final hadrons^
@@ -1564,8 +1674,8 @@
               G4cout<<"G4QE::HQ:|||Vacuum|||4-MomCHECK|||d4M="<<t4M<<",dC="<<tC<<G4endl;//^
 #endif
-		          }                                    // End of the WHILE LOOP                 ^
-		          //if(!nOfOUT&&nQuasmons==1)          // TRY TO EVAPORATE THE TOTAL SYSTEM     ^
-		          if((!nOfOUT&&nQuasmons==1)||theEnvironment.GetPDGCode()==NUCPDG)//EvaporTotal ^
-			         {                                    //                                       ^
+            }                                    // End of the WHILE LOOP                 ^
+            //if(!nOfOUT&&nQuasmons==1)          // TRY TO EVAPORATE THE TOTAL SYSTEM     ^
+            if((!nOfOUT&&nQuasmons==1)||theEnvironment.GetPDGCode()==NUCPDG)//EvaporTotal ^
+            {                                    //                                       ^
               G4int totS=totQC.GetStrangeness(); //  Total Strangeness                    ^
               //G4int totBN=totQC.GetBaryonNumber();// Total Baryon Number                ^
@@ -1573,5 +1683,5 @@
               if(totS) totPDG-=totS*999999;      // @@ ??                                 ^
 #ifdef fdebug
-		            G4cout<<"G4QE::HQE: totPDG="<<totPDG<<",totM="<<totQM<<G4endl; //           ^
+              G4cout<<"G4QE::HQE: totPDG="<<totPDG<<",totM="<<totQM<<G4endl; //           ^
 #endif
               G4QHadron* evH = new G4QHadron(totQC,tot4M); // Create a Hadron-ResidualNucl^
@@ -1583,17 +1693,17 @@
               return theQHadrons;                //                                       ^
             }                                    //                                       ^
-		          else if(!nOfOUT)                     // Still remain not used Quasmons        ^
-			         {                                    //                                       ^
-		            G4cerr<<"***G4QE::HQ:T="<<tot4M<<totQC<<",M="<<totQM<<"< gsM=" //           ^
+            else if(!nOfOUT)                     // Still remain not used Quasmons        ^
+            {                                    //                                       ^
+              G4cerr<<"***G4QE::HQ:T="<<tot4M<<totQC<<",M="<<totQM<<"< gsM=" //           ^
                     <<gsM<<",d="<<dM<<",Env="<<theEnvironment<<G4endl; //                 ^
               throw G4QException("G4QEnvironment::HadronizeQEnv: Can't decay Quasmon");// ^
-	           }                                    //                                       ^
-		        } // End of PANIC treatment                                                     ^
-		      } // End of trouble handling with Quasmon decay in Vacuum                         ^
+            }                                    //                                       ^
+          } // End of PANIC treatment                                                     ^
+        } // End of trouble handling with Quasmon decay in Vacuum                         ^
         for_each(output->begin(), output->end(), DeleteQHadron());  // >------------------^
         output->clear();                         //                                       ^
         delete output;                           // >=====================================^
-	     } // End of check for the already decayed Quasmon
-	   } // End of the LOOP over Quasmons
+      } // End of check for the already decayed Quasmon
+    } // End of the LOOP over Quasmons
   }
   else                                           // ==> "Nuclear environment" case
@@ -1603,11 +1713,11 @@
     G4int totInC=theEnvironment.GetZ();
     G4LorentzVector totIn4M=theEnvironment.Get4Momentum();
-	   for (G4int is=0; is<nQuasmons; is++) // Sum 4mom's of Quasmons for comparison
-	   {
-	     G4Quasmon*      pQ = theQuasmons[is];
+    for (G4int is=0; is<nQuasmons; is++) // Sum 4mom's of Quasmons for comparison
+    {
+      G4Quasmon*      pQ = theQuasmons[is];
       G4LorentzVector Q4M= pQ->Get4Momentum();
       totIn4M           += Q4M;
       totInC            += pQ->GetQC().GetCharge();
-	   } // End of TotInitial4Momentum summation LOOP over Quasmons
+    } // End of TotInitial4Momentum summation LOOP over Quasmons
     G4int nsHadr  = theQHadrons.size();        // Update the value of OUTPUT entries
     if(nsHadr) for(G4int jso=0; jso<nsHadr; jso++)// LOOP over output hadrons 
@@ -1649,6 +1759,8 @@
     //G4int nCnMax = 9;                      // MaxCounterOfHadrFolts for shortCutSolutions
     G4bool first=true;                     // Flag of the first interaction (only NucMedia)
+    G4int cAN=0;                           // Counter of the nucleon absorptions
+    G4int mcAN=3;                          // Max for the counter of nucleon absorptions
     while (sumstat||totC<totCM)            // ===***=== The MAIN "FOREVER" LOOP ===***===
-	   {
+    {
 #ifdef chdebug
       G4int f2Charge=0;
@@ -1688,5 +1800,5 @@
 #endif
       totC++;
-      if(nQuasmons==1&&sumstat==3) cbR++;
+      if( nQuasmons==1 && sumstat==3 ) cbR++;    // Counter of dead solutions for nQ=1
       else cbR=0;
       G4QContent envQC=theEnvironment.GetQCZNS();// QuarkCont of current NuclearEnvironment
@@ -1699,8 +1811,8 @@
       G4int     nCount=0;                        // Counter of notsuccessful fragmentations
       G4int     fCount=0;                        // Counter of successful(notFinal) fragm's
-	     G4int     eCount=0;                        // Counter of not yet decayed Quasmons
-	     for (G4int iq=0; iq<nQuasmons; iq++)       // Sum up Quasmons for making a decision
-	     {
-	       G4Quasmon*      pQ = theQuasmons[iq];
+      G4int     eCount=0;                        // Counter of not yet decayed Quasmons
+      for (G4int iq=0; iq<nQuasmons; iq++)       // Sum up Quasmons for making a decision
+      {
+        G4Quasmon*      pQ = theQuasmons[iq];
         G4QContent      QQC= pQ->GetQC();
         totQC             += QQC;
